package problem3;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

public class MainFrame extends JFrame {
	int inputFileState=0;
	int outputFileState=0;
	File inputFile;
	File outputFile;
	JTextField inputFileText=new JTextField("̓t@C");
	JTextField outputFileText=new JTextField("o̓t@C");
	JButton inputFileSetter=new JButton("Q");
	JButton outputFileSetter=new JButton("Q");
	JButton start=new JButton("s");
	public MainFrame(){
		this.setLayout(new GridLayout(3,3));
		//add
		inputFileText.setEnabled(false);
		outputFileText.setEnabled(false);
		start.setEnabled(false);
		Container container=this.getContentPane();
		container.add(new JLabel("̓t@C"));
		container.add(inputFileText);
		container.add(inputFileSetter);
		container.add(new JLabel("o̓t@C"));
		container.add(outputFileText);
		container.add(outputFileSetter);
		container.add(new JLabel(""));
		container.add(start);
		container.add(new JLabel(""));
		//setting
		this.setLocationRelativeTo(null);
		this.setTitle("ۑ3");
		this.pack();
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		//listener
		inputFileSetter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fileChooser=new JFileChooser();
				fileChooser.setDialogTitle("̓t@C");
				if(fileChooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
					inputFile=fileChooser.getSelectedFile();
					inputFileText.setText(inputFile.getAbsolutePath());
					inputFileState=1;
					if(outputFileState==1){
						start.setEnabled(true);
					}
				}
			}
		});
		outputFileSetter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fileChooser=new JFileChooser();
				fileChooser.setDialogTitle("o̓t@C");
				if(fileChooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
					outputFile=fileChooser.getSelectedFile();
					outputFileText.setText(outputFile.getAbsolutePath());
					outputFileState=1;
					if(inputFileState==1){
						start.setEnabled(true);
					}
				}
			}
		});
		start.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				try {
					//input-output open
					FileReader reader=new FileReader(inputFile);
					BufferedReader input=new BufferedReader(reader);
					outputFile.createNewFile();
					FileWriter writer=new FileWriter(outputFile);
					BufferedWriter output=new BufferedWriter(writer);
					//calculate
					//read m
					int dataSetNum=Integer.parseInt(input.readLine());
					for(int m=0;m<dataSetNum;m++){
						//read money
						int initialMoney=Integer.parseInt(input.readLine());
						int MaxMoney=initialMoney;
						//read year
						int year=Integer.parseInt(input.readLine());
						//read n
						int wayNum=Integer.parseInt(input.readLine());
						//calculate
						for(int n=0;n<wayNum;n++){
							int money=initialMoney;
							int balance=initialMoney;
							int interest=0;
							//read way
							String way[]=input.readLine().split(" ");

							switch(Integer.parseInt(way[0])){
							case 0://simple interest
								for(int y=0;y<year;y++){
									interest+=(int)(balance*Double.parseDouble(way[1]));
									balance-=Integer.parseInt(way[2]);
									money=balance+interest;
								}
								break;
							case 1://compound interest
								for(int y=0;y<year;y++){
									interest=(int)(money*Double.parseDouble(way[1]));
									money+=(interest-Integer.parseInt(way[2]));
								}
								break;
							}

							//max?
							MaxMoney=Math.max(MaxMoney,money);
						}
						//output
						output.write(Integer.toString(MaxMoney));
						output.newLine();
						output.flush();
					}
					//input-output close				
					input.close();
					output.close();
					JOptionPane.showMessageDialog(null,"I܂B");
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		});
	}
}
